﻿--[[
--                                           TJS ©2009 through 2015 or (c)2009 through 2015
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
-- Global Variables - Creation - Initialization
--------------------------------------------------------------------------------------------------------------------------------
local TJS_Color = {
	["Stalk"] = "|cffA4FCA4";
	["Token"] = "|cff01B8FB";
	["Plans"] = "|cffFAD996";
};
local Color = "|cff71FB73";
local PrintHead = Color.."-----------<Tanaan Jungle Stalker>------------|r"
local PrintLine = Color.."------------------------------------------------------|r";

function TJS_InitializeVar()
	TJS["Info"] = {};
	TJS["Info"]["Player"] = UnitName("player");
	TJS["Info"]["Faction"] = UnitFactionGroup("player");
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffTJS Faction"..TJS["Faction"].."|r");
	TJS["Info"]["Realm"] = GetRealmName();
	TJS["Info"]["RealmID"] = string.gsub(TJS["Info"]["Realm"], " ", "");
	TJS["Info"]["RealmAbb"] = string.sub(TJS.Info.RealmID, 1, 3);
	TJS["Info"]["PlayerID"] = TJS["Info"]["Player"].."-"..TJS["Info"]["RealmID"];
	TJS["Info"]["ChatID"] = TJS.Info.Player.."-"..TJS.Info.RealmAbb;
	TJS["Info"]["ID"] = TJS["Info"]["PlayerID"].."-"..TJS["Info"]["Faction"];
	TJS["Info"]["Class"], TJS["Info"]["ClassFileName"] = UnitClass("player");
	TJS["Info"]["ClassColor"] = RAID_CLASS_COLORS[TJS.Info.ClassFileName];
	TJS["Info"]["PlayerColor"] = "|c"..TJS.Info.ClassColor.colorStr..TJS.Info.Player.."|r";
	TJS["Info"]["PlayerClassColor"] = "|c"..TJS.Info.ClassColor.colorStr..TJS.Info.Class.."|r";
	TJSLOADED = true;
end

local TJS_inCave = "\n|cffFB693DLOCATED IN CAVE|r\nsee Cave Entrance";
local TJS_CaveEnt = "|cffFB693DCAVE ENTRANCE|r\n";
local TJS_Summon = "\n|cffFBE23DMust be SUMMONED|r";
local TJS_Event = "\n|cff41D344Spawns as an EVENT|r";

function TJS_Create(x,y,name)
	TJS.Stalk[name] = {
		["c"] = 7,
		["z"] = 8,
		["x"] = x,
		["y"] = y,
		["name"] = name,
		["title"] = TJS_Color.Stalk..name.."|r",
		["stalkFlag"] = false,
		["todayNum"] = 0,
		["todayFlag"] = false,
	};
end

function TJS_CreateStalk()
	TJS_Create(54.3,81.0,"Akrrilo");
	TJS_Create(53.0,40.6,"Argosh the Destroyer");
	TJS_Create(34.9,47.1,"Belgork");
	TJS_Create(23.8,51.9,"Bilkor the Thrower");
	TJS_Create(50.0,74.0,"Bleeding Hollow Horror");
	TJS_Create(21.2,42.2,"Bloodhunter Zulk");
	TJS_Create(40.7,69.8,"Bramblefell");
	TJS_Create(57.4,67.9,"Broodlord Ixkor");
	TJS_Create(48.0,57.2,"Captain Grok'mar");
	TJS_Create(35.6,79.9,"(The Real) Captain Ironbeard");
	TJS_Create(30.9,68.3,"Ceraxas");
	TJS_Create(44.4,37.3,"Cindral the Wildfire");
	TJS_Create(15.2,54.5,"Commander Krag'goth");
	TJS_Create(51.0,46.0,"Commander Org'mok");
	TJS_Create(23.5,46.8,"Dorg the Bloody");
	TJS_Create(19.8,53.6,"Driss Vile");
	TJS_Create(25.1,46.6,"Drivnul");
	TJS_Create(49.5,36.5,"Executor Riloth");
	TJS_Create(54.3,81.0,"Eyepiercer");
	TJS_Create(28.7,51.0,"Felbore");
	TJS_Create(45.8,47.0,"Felsmith Damorka");
	TJS_Create(52.0,26.4,"Felspark");
	TJS_Create(63.2,80.0,"Gloomtalon");
	TJS_Create(34.5,78.3,"Glub'glok");
	TJS_Create(33.3,35.8,"Gorabosh");
	TJS_Create(47.5,42.3,"Grand Warlock Nethekurse");
	TJS_Create(15.9,59.7,"Grannok");
	TJS_Create(39.6,32.6,"Harbormaster Korak");
	TJS_Create(31.5,73.5,"Imp-Master Valessa");
	TJS_Create(26.8,76.1,"Jax'zor");
	TJS_Create(52.0,83.8,"Krell the Serene");
	TJS_Create(39.6,68.4,"Kris'kar the Unredeemed");
	TJS_Create(32.5,74.0,"Lady Oran");
	TJS_Create(52.4,62.5,"Magwia");
	TJS_Create(25.5,79.2,"Mistress Thavra");
	TJS_Create(53.0,20.0,"Overlord Ma'gruth");
	TJS_Create(53.6,21.6,"Painmistress Selora");
	TJS_Create(16.8,48.8,"Podlord Wakkawam");
	TJS_Create(56.7,24.7,"Putre'thar");
	TJS_Create(16.8,44.7,"Rasthe");
	TJS_Create(26.3,54.9,"Relgor");
	TJS_Create(54.3,81.0,"Rendarr");
	TJS_Create(43.0,73.9,"Rendrak");
	TJS_Create(20.5,49.8,"Rogond the Tracker");
	TJS_Create(43.0,36.9,"Sergeant Mor'grak");
	TJS_Create(49.7,61.2,"Shadowthrash");
	TJS_Create(62.2,73.0,"Soulslicer");
	TJS_Create(65.2,37.0,"Steelsnout");
	TJS_Create(40.5,79.2,"Sylissa");
	TJS_Create(16.1,57.4,"Szirek the Twisted");
	TJS_Create(48.9,73.5,"The Blackfang");
	TJS_Create(34.9,72.5,"The Goreclaw");
	TJS_Create(13.0,57.0,"The Iron Houndmaster");
	TJS_Create(37.0,72.0,"The Night Haunter");
	TJS_Create(13.4,58.6,"Tho'gar Gorefist");
	TJS_Create(34.1,44.3,"Thromma the Gutslicer");
	TJS_Create(27.6,32.8,"Varyx the Damned");
	TJS_Create(60.0,21.2,"Xanzith the Everlasting");
	TJS_Create(48.4,28.6,"Zeter'el");
	TJS_Create(37.0,32.8,"Zoug the Heavy");
end

function TJS_SetStalkTodayNum(x, name)
	if TJS.Stalk[name] then
		TJS.Stalk[name]["todayNum"] = x;
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00B2FE<TJS>:|r|cffFF0000"..name.."|r");
	end
end

function TJS_InitStalkTodayNum()
	TJS_SetStalkTodayNum(39399, "Akrrilo");
	TJS_SetStalkTodayNum(38430, "Argosh the Destroyer");
	TJS_SetStalkTodayNum(38609, "Belgork");
	TJS_SetStalkTodayNum(38262, "Bilkor the Thrower");
	TJS_SetStalkTodayNum(38696, "Bleeding Hollow Horror");
	TJS_SetStalkTodayNum(38266, "Bloodhunter Zulk");
	TJS_SetStalkTodayNum(38209, "Bramblefell");
	TJS_SetStalkTodayNum(38589, "Broodlord Ixkor");
	TJS_SetStalkTodayNum(38820, "Captain Grok'mar");
	TJS_SetStalkTodayNum(38756, "(The Real) Captain Ironbeard");
	TJS_SetStalkTodayNum(38031, "Ceraxas");
	TJS_SetStalkTodayNum(37990, "Cindral the Wildfire");
	TJS_SetStalkTodayNum(38746, "Commander Krag'goth");
	TJS_SetStalkTodayNum(38749, "Commander Org'mok");
	TJS_SetStalkTodayNum(38265, "Dorg the Bloody");
	TJS_SetStalkTodayNum(38736, "Driss Vile");
	TJS_SetStalkTodayNum(38264, "Drivnul");
	TJS_SetStalkTodayNum(38411, "Executor Riloth");
	TJS_SetStalkTodayNum(39379, "Eyepiercer");
	TJS_SetStalkTodayNum(38775, "Felbore");
	TJS_SetStalkTodayNum(38634, "Felsmith Damorka");
	TJS_SetStalkTodayNum(38211, "Felspark");
	TJS_SetStalkTodayNum(38604, "Gloomtalon");
	TJS_SetStalkTodayNum(38764, "Glub'glok");
	TJS_SetStalkTodayNum(38709, "Gorabosh");
	TJS_SetStalkTodayNum(38400, "Grand Warlock Nethekurse");
	TJS_SetStalkTodayNum(38750, "Grannok");
	TJS_SetStalkTodayNum(39046, "Harbormaster Korak");
	TJS_SetStalkTodayNum(38026, "Imp-Master Valessa");
	TJS_SetStalkTodayNum(38030, "Jax'zor");
	TJS_SetStalkTodayNum(38605, "Krell the Serene");
	TJS_SetStalkTodayNum(38825, "Kris'kar the Unredeemed");
	TJS_SetStalkTodayNum(38029, "Lady Oran");
	TJS_SetStalkTodayNum(38726, "Magwia");
	TJS_SetStalkTodayNum(38032, "Mistress Thavra");
	TJS_SetStalkTodayNum(38580, "Overlord Ma'gruth");
	TJS_SetStalkTodayNum(38557, "Painmistress Selora");
	TJS_SetStalkTodayNum(38282, "Podlord Wakkawam");
	TJS_SetStalkTodayNum(38457, "Putre'thar");
	TJS_SetStalkTodayNum(38034, "Rasthe");
	TJS_SetStalkTodayNum(38496, "Relgor");
	TJS_SetStalkTodayNum(39400, "Rendarr");
	TJS_SetStalkTodayNum(38631, "Rendrak");
	TJS_SetStalkTodayNum(38263, "Rogond the Tracker");
	TJS_SetStalkTodayNum(37953, "Sergeant Mor'grak");
	TJS_SetStalkTodayNum(38812, "Shadowthrash");
	TJS_SetStalkTodayNum(38600, "Soulslicer");
	TJS_SetStalkTodayNum(38700, "Steelsnout");
	TJS_SetStalkTodayNum(38628, "Sylissa");
	TJS_SetStalkTodayNum(38752, "Szirek the Twisted");
	TJS_SetStalkTodayNum(38597, "The Blackfang");
	TJS_SetStalkTodayNum(38654, "The Goreclaw");
	TJS_SetStalkTodayNum(38751, "The Iron Houndmaster");
	TJS_SetStalkTodayNum(38632, "The Night Haunter");
	TJS_SetStalkTodayNum(38747, "Tho'gar Gorefist");
	TJS_SetStalkTodayNum(38620, "Thromma the Gutslicer");
	TJS_SetStalkTodayNum(37937, "Varyx the Damned");
	TJS_SetStalkTodayNum(38579, "Xanzith the Everlasting");
	TJS_SetStalkTodayNum(38207, "Zeter'el");
	TJS_SetStalkTodayNum(39045, "Zoug the Heavy");
end

function TJS_SetSpecial()
	local c, z, x, y = 7, 8, 0, 0;
	local name = "";
	
	TJS.Stalk["Painmistress Selora"]["event"] = true;
--------------------------------------------------------------------
	TJS.Stalk["Szirek the Twisted"]["summon"] = true;
	TJS.Stalk["Dorg the Bloody"]["summon"] = true;
	TJS.Stalk["Rendrak"]["summon"] = true;
	TJS.Stalk["Akrrilo"]["summon"] = true;
	TJS.Stalk["Eyepiercer"]["summon"] = true;
	TJS.Stalk["The Night Haunter"]["summon"] = true;
	TJS.Stalk["Rendarr"]["summon"] = true;
--------------------------------------------------------------------
	name = "(The Real) Captain Ironbeard";
	x = 37.5;
	y = 76.0;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);
	
	name = "Podlord Wakkawam";
	x = 16.8;
	y = 48.7;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "Zeter'el";
	x = 48.2;
	y = 32.8;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "Jax'zor";
	x = 29.6;
	y = 70.6;
	title = TJS.Stalk["Jax'zor"]["title"].."\n"..TJS.Stalk["Mistress Thavra"]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "Mistress Thavra";
	x = 29.6;
	y = 70.6;
	title = TJS.Stalk["Jax'zor"]["title"].."\n"..TJS.Stalk["Mistress Thavra"]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "Gloomtalon";
	x = 62.2;
	y = 79.1;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "The Blackfang";
	x = 51.3;
	y = 75.3;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "The Goreclaw";
	x = 36.6;
	y = 72.3;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "Kris'kar the Unredeemed";
	x = 42.3;
	y = 68.8;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "Thromma the Gutslicer";
	x = 38.3;
	y = 44.4;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "Felbore";
	x = 30.4;
	y = 52.6;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);

	name = "Bleeding Hollow Horror";
	x = 44.5;
	y = 77.5;
	title = TJS.Stalk[name]["title"];
	TJS_SetCave(c, z, x, y, name, title);
end

function TJS_SetCave(c, z, x, y, name, title)
	TJS.Stalk[name]["cave"] = {
		["c"] = c,
		["z"] = z,
		["x"] = x,
		["y"] = y,
		["title"] = TJS_CaveEnt..title,
	};
end

function TJS_SetSummon(title)
	temp = title..TJS_Summon;
	return temp;
end

function TJS_FromStalker()
	TJS.Plans["Belgork"] = TJS.Stalk["Belgork"];
	TJS.Plans["(The Real) Captain Ironbeard"] = TJS.Stalk["(The Real) Captain Ironbeard"];
	TJS.Plans["Cindral the Wildfire"] = TJS.Stalk["Cindral the Wildfire"];
	TJS.Plans["Felsmith Damorka"] = TJS.Stalk["Felsmith Damorka"];
	TJS.Plans["Xanzith the Everlasting"] = TJS.Stalk["Xanzith the Everlasting"];
	TJS.Plans["Zoug the Heavy"] = TJS.Stalk["Zoug the Heavy"];
end

function TJS_ToStalker()
	TJS.Stalk["Belgork"] = TJS.Plans["Belgork"];
	TJS.Stalk["(The Real) Captain Ironbeard"] = TJS.Plans["(The Real) Captain Ironbeard"];
	TJS.Stalk["Cindral the Wildfire"] = TJS.Plans["Cindral the Wildfire"];
	TJS.Stalk["Felsmith Damorka"] = TJS.Plans["Felsmith Damorka"];
	TJS.Stalk["Xanzith the Everlasting"] = TJS.Plans["Xanzith the Everlasting"];
	TJS.Stalk["Zoug the Heavy"] = TJS.Plans["Zoug the Heavy"];
end

function TJS_CreatePlans()
	TJS_FromStalker();
	
	local color = TJS_Color.Plans;
	local name = "Savage Whale Shark";
	local quest = 39355;
	local plan = "Trained Shark Tank (Counters: Minelayer)";
	TJS.Plans[name] = {
		["c"] = 7,
		["z"] = 8,
		["x"] = 38.0,
		["y"] = 30.0,
		["name"] = name,
		["title"] = color..name.."|r",
		["warning"] = "\n|cffFF0000Requires a LARGE GROUP|r",
		["todayNum"] = 36153,
		["todayFlag"] = false,
		["planName"] = "\n|cffFFFFFF"..plan.."|r",
		["planNum"] = quest,
		["planFlag"] = false,
	};

	name = "Belgork";
	quest = 38932;
	plan = "Bilge Pump (Counters: Stormy Weather)";
	TJS.Plans[name]["title"] = color..name.."|r";
	TJS.Plans[name]["planNum"] = quest;
	TJS.Plans[name]["planName"] = "\n"..plan.."|r";

	name = "(The Real) Captain Ironbeard";
	quest = 39365;
	plan = "Ghostly Spyglass (Counters: Cursed  Crew)";
	TJS.Plans[name]["title"] = color..name.."|r";
	TJS.Plans[name]["planNum"] = quest;
	TJS.Plans[name]["planName"] = "\n"..plan.."|r";

	name = "Cindral the Wildfire";
	quest = 39363;
	plan = "Ice Cutter (Counters: Icy Water)";
	TJS.Plans[name]["title"] = color..name.."|r";
	TJS.Plans[name]["planNum"] = quest;
	TJS.Plans[name]["planName"] = "\n"..plan.."|r";

	name = "Felsmith Damorka";
	quest = 39366;
	plan = "Felsmoke Launcher (Counters: First Strike)";
	TJS.Plans[name]["title"] = color..name.."|r";
	TJS.Plans[name]["planNum"] = quest;
	TJS.Plans[name]["planName"] = "\n"..plan.."|r";

	name = "Xanzith the Everlasting";
	quest = 39356;
	plan = "High Intensity Fog Lights (Counters: Dense Fog)";
	TJS.Plans[name]["title"] = color..name.."|r";
	TJS.Plans[name]["planNum"] = quest;
	TJS.Plans[name]["planName"] = "\n"..plan.."|r";

	name = "Zoug the Heavy";
	quest = 39360;
	plan = "True Iron Rudder (Counters: Evasive)";
	TJS.Plans[name]["title"] = color..name.."|r";
	TJS.Plans[name]["planNum"] = quest;
	TJS.Plans[name]["planName"] = "\n"..plan.."|r";
	
	TJS_ToStalker();
end

function TJS_CreateTokens()
	local color = TJS_Color.Token;
	local name = "";
	local x = 0.0;
	local y = 0.0;
	local today = 0;

	name = "Deathtalon";
	title = "<Avatar of Iskar>"
	x = 23.2;
	y = 40.4;
	today = 39287;
	TJS.Token[name] = {
		["c"] = 7,
		["z"] = 8,
		["x"] = x,
		["y"] = y,
		["name"] = name,
		["title"] = color..name.."|r\n"..title,
		["todayNum"] = today,
		["todayFlag"] = false,
	};

	name = "Terrorfist";
	title = "<Son of Kormrok>"
	x = 15.4;
	y = 63.6;
	today = 39288;
	TJS.Token[name] = {
		["c"] = 7,
		["z"] = 8,
		["x"] = x,
		["y"] = y,
		["name"] = name,
		["title"] = color..name.."|r\n"..title,
		["todayNum"] = today,
		["todayFlag"] = false,
	};

	name = "Doomroller";
	title = "<Mar'tak's Creation>"
	x = 47.0;
	y = 52.6;
	today = 39289;
	TJS.Token[name] = {
		["c"] = 7,
		["z"] = 8,
		["x"] = x,
		["y"] = y,
		["name"] = name,
		["title"] = color..name.."|r\n"..title,
		["todayNum"] = today,
		["todayFlag"] = false,
	};

	name = "Vengeance";
	title = "<Avatar of Velhari>"
	x = 32.4;
	y = 74.0;
	today = 39290;
	TJS.Token[name] = {
		["c"] = 7,
		["z"] = 8,
		["x"] = x,
		["y"] = y,
		["name"] = name,
		["title"] = color..name.."|r\n"..title,
		["todayNum"] = today,
		["todayFlag"] = false,
	};
end

function TJS_FinalizeTitles()
	local title = "";
	for n,a in pairs(TJS.Stalk) do
		title = a.title;
		x = title;
		if a.planName then
			title = x..a.planName
		end
		x = title;
		if a.cave then
			title = x..TJS_inCave;
		end
		x = title;
		if a.event then
			title = x..TJS_Event;
		end
		if a.summon then
			title = x..TJS_Summon;
		end
		a.title = title;
	end
	TJS_FromStalker();
end

--------------------------------------------------------------------------------------------------------------------------------
-- OPERATION
--------------------------------------------------------------------------------------------------------------------------------
function TJS_UpdateFlags()
	for i = 1, GetAchievementNumCriteria(10070) do
		local name, v, complete = GetAchievementCriteriaInfo(10070, i);
		TJS.Stalk[name]["stalkFlag"] = complete;
		local x = TJS.Stalk[name]["todayNum"];
		if x>0 then
			TJS.Stalk[name]["todayFlag"] = IsQuestFlaggedCompleted(x);
		end
	end
	local x = 0;
	TJS_FromStalker();
	for n,a in pairs(TJS.Plans) do
		x = a.planNum;
		if x>0 then
			a.planFlag = IsQuestFlaggedCompleted(x);
		else
			TJS_Sound("error");
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF0000ERROR - NO Plan Number|r");
		end
	end
	TJS_ToStalker();
	x = 0;
	for n,a in pairs(TJS.Token) do
		x = a.todayNum;
		if x>0 then
			a.todayFlag = IsQuestFlaggedCompleted(x);
		else
			TJS_Sound("error");
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF0000ERROR - NO Daily Number|r");
		end
	end
--	DEFAULT_CHAT_FRAME:AddMessage(Color.."<Tanaan Jungle Stalker>|r Updated.");
end

function TJS_TaxiExit()
--DEFAULT_CHAT_FRAME:AddMessage(Color.."<Tanaan Jungle Stalker>|rExit Entry  a=".. TJS_Taxi.a.." b="..TJS_Taxi.b);
		local a, b = TJS_Taxi.a, TJS_Taxi.b;
		TJS_SetSelected(a, b);
		TJS_Taxi.active = false; TJS_Taxi.a = "none"; TJS_Taxi.b = "none";
end

function TJS_TaxiCheck(a, b)
	local value = false;
	if TJS_Taxi.clear then
		TJS_Taxi.clear = value;
		return value;
	end
	TJS_Taxi.active = false;
	value = UnitOnTaxi("player");
	
	if value then
		if a == "info" then
			TJS_Taxi.active = false;
			value = false;
		elseif a == "p" then
			TJS_Taxi.active = true;
		elseif a == "t" then
			TJS_Taxi.active = true;
		elseif a == "s" then
			TJS_Taxi.active = true;
		elseif a == "a" then
			TJS_Taxi.active = true;
		end
	end
	if TJS_Taxi.active then
		if a then TJS_Taxi.a = a; end
		if b then TJS_Taxi.b = b; else TJS_Taxi.b="none"; end
		TJS_TaxiPrint();
	end
	return value;
end

function TJS_SetSelected(a, b)
	if not TJS_TaxiCheck(a, b) then
		local noskip = true;
		TJS_NoPoints = true;
		TJS_UpdateFlags();
--DEFAULT_CHAT_FRAME:AddMessage(Color.."<Tanaan Jungle Stalker>|r setting Waypoints.");
		if a == "info" then
			TJS_PrintInfo();
			noskip = false;
		elseif a == "p" then
			TJS_SetPlanMarks(b);
		elseif a == "t" then
			TJS_SetTokenMarks(b);
		elseif a == "s" then
			TJS_SetStalkMarks(b);
		elseif a == "a" then
			if b ~= "a" then b = "none"; end
			TJS_SetPlanMarks(b);
			TJS_SetTokenMarks(b);
			TJS_SetStalkMarks(b);
		else
			TJS_BadMessage(a);
		end
		if TJS_NoPoints then
			local warntext = "No Waypoints fit the Criteria."
			RaidNotice_AddMessage(RaidBossEmoteFrame, "<Tanaan Jungle Stalker>", ChatTypeInfo["RAID_BOSS_EMOTE"]);
			RaidNotice_AddMessage(RaidBossEmoteFrame, warntext, ChatTypeInfo["RAID_WARNING"]);
			TJS_Sound("error");
		elseif noskip then
			DEFAULT_CHAT_FRAME:AddMessage(Color.."<Tanaan Jungle Stalker>|r Waypoints Set.");
			TJS_Sound("action");
		end
	end
end

function TJS_SetPlanMarks(which)
	local set = false;
	for n,a in pairs(TJS.Plans) do
		set = false;
		if a.planFlag then
			if which == "a" then
				set= true;
			elseif which == "d" and not a.todayFlag then
				set= true;
			end 
		else
			set= true;
		end
		if set then
			TJS_SetWaypoint(a.c, a.z, a.x, a.y, a.title);
			if a.cave then
				c = a.cave;
				TJS_SetWaypoint(c.c, c.z, c.x, c.y, c.title);
			end
		end
	end
end

function TJS_SetTokenMarks(which)
	for n,a in pairs(TJS.Token) do
		if a.todayFlag then
			if which == "a" then
				TJS_SetWaypoint(a.c, a.z, a.x, a.y, a.title);
			end
		else
			TJS_SetWaypoint(a.c, a.z, a.x, a.y, a.title);
		end
	end
end

function TJS_SetStalkMarks(which)
	local c = {};
	for n,a in pairs(TJS.Stalk) do
		set = false;
		if a.stalkFlag then
			if which == "a" then
				set= true;
			elseif which == "d" and not a.todayFlag then
				set= true;
			end 
		else
			set= true;
		end
		if set then
			TJS_SetWaypoint(a.c, a.z, a.x, a.y, a.title);
			if a.cave then
				c = a.cave;
				TJS_SetWaypoint(c.c, c.z, c.x, c.y, c.title);
			end
		end
	end
end

function TJS_SetWaypoint(c, z, x, y, title)
	TJS_NoPoints = false;
	TomTom:AddZWaypoint(c, z, x, y, title);
end

--------------------------------------------------------------------------------------------------------------------------------
-- PRINTOUT
--------------------------------------------------------------------------------------------------------------------------------
function TJS_PrintMenu()
	DEFAULT_CHAT_FRAME:AddMessage(PrintHead);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS>|r  File: "..TJS_FILENUM.."|cff00ffff by Drae|r");
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS>|r  Player: "..TJS.Info.PlayerColor.." = "..TJS.Info.Realm.." <> "..TJS.Info.Faction.." <> "..TJS.Info.PlayerClassColor);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS> Menu options:|r (use /tjs or /stalker)");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("");
	DEFAULT_CHAT_FRAME:AddMessage(Color.."p = PLAN, t = TOKEN, s = STALKER");
	DEFAULT_CHAT_FRAME:AddMessage(Color.."d = DAY (Daily or Today) - a = ALL");
	DEFAULT_CHAT_FRAME:AddMessage("");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r = Prints this menu (Force Update).");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 info|r = Print Plan and Token Status (|cff00FF00Done|r - |cffFF0000Undone|r).");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 p|r = Mark PLAN rares NEEDED.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 p d|r = Mark PLAN rares not killed today.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 p a|r = Mark ALL 7 PLAN rares.");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 t|r = Mark TOKEN rares not killed today.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 t a|r = Mark ALL 4 TOKEN rares.");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 s|r = Mark STALKER rares NEEDED.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 s d|r = Mark STALKER rares not killed today.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 s a|r = Mark ALL STALKER rares.");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 a|r = Same as /tjs p + /tjs t + /tjs s");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /tjs|r|cff00ff00 a a|r = Same as /tjs p a + /tjs t a + /tjs s a");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	TJS_UpdateFlags();
end

function TJS_PrintInfo()
	TJS_NoPoints = false;
	DEFAULT_CHAT_FRAME:AddMessage(PrintHead);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."PLAN Rares:|r");
	for n,a in pairs(TJS.Plans) do
		local x = a.planNum;
		if a.planFlag then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00FF00"..n.."|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF0000"..n.."|r");
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."TOKEN Rares:|r");
	for n,a in pairs(TJS.Token) do
		local x = a.planNum;
		if a.todayFlag then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00FF00"..n.."|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF0000"..n.."|r");
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
end

function TJS_TaxiPrint()
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS>|r|cffFFA051 No TomTom waypoints set while on a taxi.|r");
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS>|r|cff6DFAAC WAYPOINTS will be SET upon LANDING.|r");
	warntext = "WAYPOINTS will be SET upon LANDING";
	RaidNotice_AddMessage(RaidBossEmoteFrame, warntext, ChatTypeInfo["RAID_BOSS_EMOTE"]);
--	RaidNotice_AddMessage(RaidBossEmoteFrame, warntext, ChatTypeInfo["RAID_WARNING"]);
	TJS_Sound("error");
end

function TJS_Sound(sound)
	if sound == "error" then PlaySound("igQuestFailed", "Master") end
--	if sound == "error" then PlaySound("RaidWarning", "Master") end
--	if sound == "action" then PlaySound("igPlayerInvite", "Master"); end
	if sound == "action" then PlaySound("LEVELUPSOUND", "master"); end
end

function TJS_BadMessage(message, badmessage)
	TJS_Sound("error");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage(Color.."<TJS>|r|cffFA5151 Unable to understand command: |cffffff00"..message.."|r");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
end

